summaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
author Andrzej Telszewski <atelszewski@gmail.com>2015-08-30 10:55:08 +0700
committer Willy Sudiarto Raharjo <willysr@slackbuilds.org>2015-08-30 10:55:08 +0700
commit21e959dc264dd41d5e717cff3fa22b00d1ab813e (patch)
treef38136625e94aa8512bebb257c2499923b961fc4
parentec4931fc3cc9ef0c712fc66460ee608e4937080b (diff)
downloadslackbuilds-21e959dc2.tar.gz
slackbuilds-21e959dc2.tar.xz
development/J-Link: Added (software and documentation for J-Link).
Signed-off-by: Willy Sudiarto Raharjo <willysr@slackbuilds.org>
-rw-r--r--development/J-Link/J-Link.SlackBuild122
-rw-r--r--development/J-Link/J-Link.info10
-rw-r--r--development/J-Link/README16
-rw-r--r--development/J-Link/slack-desc19
4 files changed, 167 insertions, 0 deletions
diff --git a/development/J-Link/J-Link.SlackBuild b/development/J-Link/J-Link.SlackBuild
new file mode 100644
index 0000000000..5cadb2eff2
--- /dev/null
+++ b/development/J-Link/J-Link.SlackBuild
@@ -0,0 +1,122 @@
+#!/bin/sh
+
+# Slackware build script for SEGGER J-Link
+
+# Copyright 2015 Andrzej Telszewski, Sabadell
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+PRGNAM=J-Link
+VERSION=${VERSION:-5.02}
+SRCNAM="JLink_Linux_V"$(echo $VERSION | tr -d .)"_"
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo}
+
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) ARCH=i486 ;;
+ arm*) ARCH=arm ;;
+ *) ARCH=$( uname -m ) ;;
+ esac
+fi
+
+CWD=$(pwd)
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+if [ "$ARCH" = "x86_64" ]; then
+ LIBDIRSUFFIX="64"
+else
+ LIBDIRSUFFIX=""
+fi
+
+if [ "$ARCH" != "i486" ] && [ "$ARCH" != "x86_64" ]; then
+ echo -ne "\n\nError: \"${ARCH}\" architecture is not supported.\n\n"
+ exit 1
+fi
+
+if [ "$ARCH" = "i486" ]; then
+ SRCNAM="${SRCNAM}i386"
+else
+ SRCNAM="${SRCNAM}$ARCH"
+fi
+
+set -e
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP
+rm -rf $PRGNAM-$VERSION
+tar xvf $CWD/$SRCNAM.tgz
+mv $SRCNAM $PRGNAM-$VERSION
+cd $PRGNAM-$VERSION
+
+TREE_MD5=80fa37c7583e6eb366e15c1fc84e630f
+UDEV_MD5=4918ffb129c5691e8f9a01313f975fea
+TREE_MD5_NEW=( $(find . ! -name "libjlinkarm.so.*" ! -name "libedit.so.*" | sort | md5sum) )
+UDEV_MD5_NEW=( $(md5sum 99-jlink.rules) )
+
+if [ $TREE_MD5 != $TREE_MD5_NEW ] || [ $UDEV_MD5 != $UDEV_MD5_NEW ]; then
+ if [ $TREE_MD5 != $TREE_MD5_NEW ]; then
+ printf "\n\tThe directory structure for which this script has been written is different\n"
+ printf "\tfrom the provided one. Although most probably nothing wrong will happen,\n"
+ printf "\tit's possible there will be a missing file or a build failure.\n"
+ fi
+
+ if [ $UDEV_MD5 != $UDEV_MD5_NEW ]; then
+ printf "\n\tThe udev rules found in the provided source are different from the one\n"
+ printf "\tfor which this script has been written. Although most probably nothing\n"
+ printf "\twrong will happen, you might run into some device permissions problems.\n"
+ fi
+
+ sleep 5
+fi
+
+chown -R root:root .
+find -L . \
+ \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
+ -o -perm 511 \) -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 640 -o -perm 600 -o -perm 444 \
+ -o -perm 440 -o -perm 400 \) -exec chmod 644 {} \;
+
+mkdir -p $PKG/etc/udev/rules.d
+fromdos < 99-jlink.rules > $PKG/etc/udev/rules.d/99-jlink.rules
+sed -i 's/BUS!="usb", ACTION!="add", SUBSYSTEM!=="usb_device", GOTO="jlink_rules_end"/ACTION!="add", SUBSYSTEM!="usb", GOTO="jlink_rules_end"/' \
+ $PKG/etc/udev/rules.d/99-jlink.rules
+sed -i 's/MODE="666"/MODE="664", GROUP="plugdev"/' $PKG/etc/udev/rules.d/99-jlink.rules
+
+mkdir -p $PKG/usr/bin
+cp -a JFlashSPI_CL JLink{Exe,GDBServer,RemoteServer,RTTClient,STM32,SWOViewer} $PKG/usr/bin
+
+mkdir -p $PKG/usr/lib$LIBDIRSUFFIX
+cp -a libjlinkarm.so.* $PKG/usr/lib$LIBDIRSUFFIX
+
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a Doc/{License.txt,UM08001_JLink.pdf,ReleaseNotes/ReleaseJLink.html} \
+ $PKG/usr/doc/$PRGNAM-$VERSION
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION/samples
+cp -a Samples/JLink/* $PKG/usr/doc/$PRGNAM-$VERSION/samples
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.${PKGTYPE:-tgz}
diff --git a/development/J-Link/J-Link.info b/development/J-Link/J-Link.info
new file mode 100644
index 0000000000..59ab609a0d
--- /dev/null
+++ b/development/J-Link/J-Link.info
@@ -0,0 +1,10 @@
+PRGNAM="J-Link"
+VERSION="5.02"
+HOMEPAGE="https://www.segger.com/"
+DOWNLOAD="https://www.segger.com/jlink-software.html?step=1&file=JLinkLinuxTGZ32_502"
+MD5SUM="0f7d058711d62a2837a13f01d41caf8a"
+DOWNLOAD_x86_64="https://www.segger.com/jlink-software.html?step=1&file=JLinkLinuxTGZ64_502"
+MD5SUM_x86_64="1129746191f45657a6e24aa0e3c85b37"
+REQUIRES="libedit"
+MAINTAINER="Andrzej Telszewski"
+EMAIL="atelszewski@gmail.com"
diff --git a/development/J-Link/README b/development/J-Link/README
new file mode 100644
index 0000000000..7cd3be26cd
--- /dev/null
+++ b/development/J-Link/README
@@ -0,0 +1,16 @@
+The J-Link software gives you the USB drivers needed for your system, a number
+of utilities as well as a dynamically linkable library used by most of the IDEs
+and debuggers using J-Link. Also included are a number of sample setup scripts
+for devices needing one as well as documentation.
+
+NOTE:
+1. This SlackBuild is not sbopkg compatible because source download requires
+ licence acceptance (the link provided in .info points to download site)
+ and the source tarball name is different from the resulting package name.
+2. This SlackBuild repackages the official J-Link binary package.
+3. The official binary package bundles libedit, which is also available from
+ slackbuilds.org so I decided to go with the one from slackbuilds.org and
+ not with the bundled one. BTW, ldd shows that libedit is not used at all.
+4. The original udev rules change the device permissions to 0666.
+ This SlackBuild modifies the rules, so that the permissions are 0664 and
+ the group is plugdev. Make sure to make yourself a member of this group.
diff --git a/development/J-Link/slack-desc b/development/J-Link/slack-desc
new file mode 100644
index 0000000000..e659599c66
--- /dev/null
+++ b/development/J-Link/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description.
+# Line up the first '|' above the ':' following the base package name, and
+# the '|' on the right side marks the last column you can put a character in.
+# You must make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':' except on otherwise blank lines.
+
+ |-----handy-ruler------------------------------------------------------|
+J-Link: J-Link (software and documentation for J-Link)
+J-Link:
+J-Link: The J-Link software gives you the USB drivers needed for your system,
+J-Link: a number of utilities as well as a dynamically linkable library used
+J-Link: by most of the IDEs and debuggers using J-Link. Also included are a
+J-Link: number of sample setup scripts for devices needing one as well as
+J-Link: documentation.
+J-Link:
+J-Link:
+J-Link: Homepage: https://www.segger.com/
+J-Link: